//////////////////////////////////////////////////
//////Example Project for the WebcamApp Dll///////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
/////24.02.2009////////////////by Nils Daumann////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////

#include <acknex.h>
#include <default.c>

#define PRAGMA_PLUGIN "WebcamApp Dll.dll"
#include "WebcamApp.h"


var Width = 0;
var Height = 0;
var Size = 0;
var Refr = 0;
var Format = 0;

var BaseP1PosX = 320;
var BaseP1PosY = 240;

PANEL* Debug_pan =
{
	pos_x = 0;
	pos_y = 0;
	flags = VISIBLE;
	digits(10,10,"Width: %.0f px",*,1,Width);
	digits(10,20,"Height: %.0f px",*,1,Height);
	digits(10,30,"Size: %.0f",*,1,Size);
	digits(10,40,"Refresh: %.0f",*,1,Refr);
	digits(10,50,"Format: %.0f",*,1,Format);
}

PANEL*Output_pan =
{
	pos_x = 0;
	pos_y = 0;
	flags = VISIBLE;
}

void Quit()
{
	VD_free();
	sys_exit("");
}

void SetFormat()
{
	Format += 1;
	Format %= 18;
	VD_Format(Format);
}

void SetBase()
{
	BaseP1PosX = VD_Point_Get(0,0);
	BaseP1PosY = VD_Point_Get(0,1);
}

void main()
{
	on_esc = Quit;
	on_close = Quit;
	
	on_f = SetFormat;
	on_ctrl = VD_Settings;
	on_space = SetBase;
	
	level_load("Level.wmb");
	
	if(VD_init(640,480)/*352,288*/ != 0)
	{
		sys_exit("");
	}
	
	Output_pan.bmap = bmap_createblack(VD_GetWidth(),VD_GetHeight(),24);
	
	Width = VD_GetWidth();
	Height = VD_GetHeight();
	Size = VD_GetSize();
	
	COLOR Color;
	int x = 1;
	int y = 1;
	var format;
	var pixel;
	
	while(!key_alt)
	{
		Refr = VD_Point_BGSub_Refresh(30,250);
		
		if(VD_Point_Get(0,2) > 0)
		{
			draw_text("X",VD_Point_Get(0,0),VD_Point_Get(0,1),nullvector);
		}
		
		format = bmap_lock(Output_pan.bmap,0);
		for(y = 0; y < Height; y++)
		{
			for(x = 0; x < Width; x++)
			{
				Color.blue = VD_Color_Get(x, y, 0);
				Color.green = VD_Color_Get(x, y, 1);
				Color.red = VD_Color_Get(x, y, 2);
				
				pixel = pixel_for_vec(Color,100,format);
				pixel_to_bmap(Output_pan.bmap,x,y,pixel);
			}
		}
		bmap_unlock(Output_pan.bmap);
		
		wait(1);
	}
	
	on_ctrl = NULL;
	ptr_remove(Output_pan.bmap);
	
	reset(Output_pan,VISIBLE);
	
	while(1)
	{
		Refr = VD_Point_Refresh(250);
		
		camera.pan += (VD_Point_Get(0,0)-BaseP1PosX)*0.1*time_step;
		camera.tilt += (BaseP1PosY-VD_Point_Get(0,1))*0.1*time_step;
		
//		camera.y += (VD_Point_Get(0,0)-BaseP1PosX)*0.1*time_step;
//		camera.z += (BaseP1PosY-VD_Point_Get(0,1))*0.1*time_step;
		
		wait(1);
	}
}