//////////////////////////////////////////////////
////////Header-File for the WebcamApp Dll/////////
//////////////////////////////////////////////////
//////////////////////////////////////////////////
/////24.02.2009////////////////by Nils Daumann////
///////////////www.ssmasters.de///////////////////
//////////////////////////////////////////////////
////The dll is just a very bad wrapper////////////
////of the videoInput Library:////////////////////
//http://muonics.net/school/spring05/videoInput///
//////////////////////////////////////////////////


/**************************************************/
/*********Device handling and information**********/
/**************************************************/

//Initializes the device
//has to be called before calling
//any of the other functions!
///SizeX: horizontal resolution of the image
///SizeY: vertical resolution of the image
///Returns 0 if everything went well, 1 otherwize (f.e. no webcam found).
int VD_init(int SizeX, int SizeY);

//shuts down the device
//Has to be called before quitting the application
int VD_free();

//sets the format of the device
int VD_Format(int Format);

//opens a settings dialog
void VD_Settings();

//returns the devices width
var VD_GetWidth();

//returns the devices height
var VD_GetHeight();

//returns the devices size
var VD_GetSize();


/**************************************************/
/*********Refreshing and accessing of**************/
/*********colors and tracked points****************/
/**************************************************/

//Refresh the rgb color buffer
///Returns 0 if everything goes well, != 0 otherwize
var VD_Color_Refresh();

//Get the the color of a pixel
///PosX: X-position of the pixel
///PosY: Y-position of the pixel
///Color: 0, 1 of 2 to get the r, g or b channel
///Returns the value of the color channel as a value between 0 and 255
var VD_Color_Get(int PosX, int PosY, int Color);

//Refresh the point buffer (this also refreshes the color buffer)
///BlackOut: Tracks the 20 biggest points which are brighter than this value (0-255)
///Returns 0 if everything goes well, != 0 otherwize
var VD_Point_Refresh(int BlackOut);

//Get the points positions
///Point: Index of the point. 0 for the biggest 19 for the smallest.
///Pos: 0 or 1 depending on if you want the x or the y position.
///Returns the position of the point.
var VD_Point_Get(int Point, int Pos);



/*those were some experimental functions.
I dont really remember how far they worked or not*/

//Sets the background buffer
var VD_BG_Set(int Threshold);

//Refresh the point buffer with substracting the background
var VD_Point_BGSub_Refresh(int BlackOut, int Threshold);